
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android多线程消息处理机制 / 憋错料</title>

    <meta name="description" content="Android多线程消息处理机制 (1)主线程和ANR 主线程:UI线程,界面的修改只能在主线程中,其它线程对界面进行修改会造成异常.这样就解决了多线程竞争UI资源的问题. 一旦主线程的代码阻塞,界面将无法响应,这种行为就是Application Is Not Respond(ANR),应用失去响应. 如果主线程中某个事件操作时间超过5秒没有得到响应,Android可能会弹出一个应用程序没有响应的对话框.activity可能会被杀掉. 下面用实例来说明ANR,demo如下,这个时候按钮就会失去响应 private Button">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android多线程消息处理机制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>（1）主线程和ANR</p>
<p>主线程：UI线程，界面的修改只能在主线程中，其它线程对界面进行修改会造成异常。这样就解决了多线程竞争UI资源的问题。</p>
<p>一旦主线程的代码阻塞，界面将无法响应，这种行为就是Application Is Not Respond（ANR），应用失去响应。</p>
<p>如果主线程中某个事件操作时间超过5秒没有得到响应，Android可能会弹出一个应用程序没有响应的对话框。activity可能会被杀掉。</p>
<p>下面用实例来说明ANR，demo如下，这个时候按钮就会失去响应</p>
<pre>private Button btn;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		btn=(Button)findViewById(R.id.button1);
		btn.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				try {
					//主线程耗时操作
					Thread.sleep(10*1000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		});
	}
</pre>
<p>ANR的成因和避免：1，耗时操作是不可避免的，如网络连接和网络数据的获取，对存储器的读写，大量数据的计算，任何一种操作都有可能占用时间，例如网络不稳定，磁盘在忙，cpu被占用。 2，UI线程是负责事件的监听和绘图，因此必须保证UI线程能够随时响应用户的需求，任何对UI线程的阻塞无论时间长短都会影响用户的体验或是导致anr，UI线程中的操作要尽量的短小，耗时操作（网络连接数据访问等）要在单独的线程中完成。</p>
<p>（2）Android的消息机制，由于android中不可避免的要进行耗时操作，主线程阻塞会影响与用户的交互，需要一种机制能够通知主线程更新界面，这就是消息机制，Looper消息机制（主线程视角看消息机制，消息队列，looper循环读取消息，进行消息的回调），Handler消息机制（编程视角看消息机制）。下图就是Looper和Handler处理消息机制的图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcyOTM5NC8yMDE2MDIvNzI5Mzk0LTIwMTYwMjI5MTIyNzU3MDY0LTE5NjQ4Mzk4Mi5qcGc=.jpg" /></p>
<p>对消息队列的操作只能通过Handler来进行，当Handler的sendMessage方法时就会发送一个消息，主线程Looper就会发现消息队列的改变，并响应这个消息，消息被处理后会从队里移除，处理响应消息也是由Handler来处理，handleMessage方法。这个方法是运行在主线程中的。handler中常用的方法，void handleMessage（）方法，消息发送后通过这个方法来处理，这个方法需要重写。boolean sendEmptyMessage（int what）方法，只发送一个what值的消息。boolean sendMesssage（Message message）发送消息到handler，在handler中处理消息，sendMessageDelayed（Message msg ,long s）,removeMessages(int what)删除message/取消定时的message。<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcyOTM5NC8yMDE2MDIvNzI5Mzk0LTIwMTYwMjI5MTYzMDU3MjUxLTE2MTEwNDUwNjMucG5n.jpg" /></p>
<p>下面以一个demo来说明Handler和message的用法，demo如下</p>
<pre>package com.example.handlerdemo;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity {

	private static final int MESSAGE_OK=1;
	private static final int MESSAGE_CANCLE=2;
	private static final int MESSAGE_ARG1=3;
	private static final int MESSAGE_ARG2=4;
	private Handler handler=new Handler(){
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case MESSAGE_OK:
				txt.setText("ok");
				break;
			case MESSAGE_CANCLE:
				if(msg.arg1==MESSAGE_ARG1){
					txt.setText("cancle"+"by user");
				}else{
					txt.setText("cancle"+"by system");
				}
				break;

			default:
				break;
			}
		};
	};
	private Button btn_ok;
	private Button btn_cancle;
	private TextView txt;
	private Button btn;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		btn_cancle=(Button)findViewById(R.id.btn_cancle);
		btn_ok=(Button)findViewById(R.id.btn_ok);
		btn=(Button)findViewById(R.id.btn);
		txt=(TextView) findViewById(R.id.txt);

		btn_ok.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				/*Message msg=Message.obtain();//获取message实例的正规方法
				msg.what=MESSAGE_OK;
				handler.sendMessage(msg);
				handler.sendEmptyMessage(MESSAGE_OK);*///sendEmptyMessage的方法
				handler.sendEmptyMessageDelayed(MESSAGE_OK, 10000);//延时发送消息,还有定时发送消息的方法
			}
		});
		btn_cancle.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				Message msg=Message.obtain();
				msg.what=MESSAGE_CANCLE;
				msg.arg1=MESSAGE_ARG1;//message的参数。
				handler.sendMessage(msg);
			}
		});
		btn.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				handler.removeMessages(MESSAGE_OK);//取消发送消息
			}
		});
	}
}
</pre>
<p>在使用Message和Looper的时候我们还需要注意一下几点：1，Looper和MessageQueue是在主线程创建时就会创建的，新建线程的时候是不会默认创建的，一般情况下我们是不会去直接访问者两个对象。2，Handler必须在有Looper实例的情况下才能实例化，在新建的线程中默认是不能被实例化的，否则就会出错。3，子线程默认情况下是没有实例化Looper和MessageQueue对象的。</p>
<p>（3）Thread和Handler，handler的sendmessage()方法可以运行在其它线程中，这样我们就何以通过Thread和Handler的结合来解决耗时操作的问题，一下我们用一个动态显示进度条控件的demo来说明效果如下图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcyOTM5NC8yMDE2MDIvNzI5Mzk0LTIwMTYwMjI5MTgyMTE1Mzc2LTgxMTQyMTM1My5wbmc=.jpg" /></p>
<p>代码如下：</p>
<pre>package com.example.handlerandthreaddemo;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.TextView;

public class MainActivity extends Activity {

	private Button btnStart;
	private TextView tvDownLoad;
	private ProgressBar pbDownLoad;
	private static final int MESSAGE_NUMBER=1;
	private int i=0;
	private Handler handler=new Handler(){
		public void handleMessage(android.os.Message msg) {
			if(msg.what==MESSAGE_NUMBER){
				pbDownLoad.setProgress(i);
				tvDownLoad.setText("下载进度"+i+"%");
			}
		};
	};
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		btnStart=(Button) findViewById(R.id.btnStart);
		tvDownLoad=(TextView)findViewById(R.id.txtDownLoad);
		pbDownLoad=(ProgressBar) findViewById(R.id.pbDownLoad);

		btnStart.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				new Thread(){
					public void run() {
						while(i&lt;100){
							try {
								sleep(500);
								i++;
								Message msg=Message.obtain();
								msg.what=MESSAGE_NUMBER;
								handler.sendMessage(msg);
							} catch (InterruptedException e) {
								e.printStackTrace();
							}
						}
					};
				}.start();
			}
		});
	}
}
</pre>
<p>（4）AsyncTask线程间的异步通信。</p>
<p>AsyncTask也是一种异步加载机制，使用时要注意一下几点：1，Task的实例必须在主线程中创建，2，execute（）方法必须在主线程中调用，3，不要调用onpreExecute（），doinbackground（），onprogressUpdate（），onpostExecute（）等方法。4，该实例化后的task只能被执行一次，重复调用会出现异常。</p>
<p>AsyncTask几种常用方法：onpreExecute（）方法，该方法在执行实际的后台之前被主线程调用；doInBackground()方法，是执行耗时操作，执行在后台的进程中，是抽象方法，子类必须重写，在这个方法中调用publishprogress（）方法来实现实时跟新的任务进行；onProgressUpdate（）方法在publisprogress（）方法被调用后，UI线程调用此方法。onPostExecute（）方法是在后台操作完成后来跟新界面。下面以一个实例和效果图来说明</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcyOTM5NC8yMDE2MDMvNzI5Mzk0LTIwMTYwMzA1MTYxOTQzMTU5LTQ2Nzg3OTk4NS5wbmc=.jpg" /></p>
<p>代码</p>
<pre>package com.example.asynctask;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity {

	private Button btnStart,btn;
	private TextView tv;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		btn=(Button) findViewById(R.id.button2);
		btnStart=(Button)findViewById(R.id.button1);
		tv=(TextView) findViewById(R.id.textView1);
		btnStart.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				MyAsyncTask myTask=new MyAsyncTask();
				myTask.execute();
			}
		});
		btn.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {

			}
		});
	}
	class MyAsyncTask extends AsyncTask&lt;Void, Void, Void&gt;{

		@Override
		protected void onPreExecute() {
			tv.setText("之前");
			super.onPreExecute();
		}
		@Override
		protected void onProgressUpdate(Void... values) {
			super.onProgressUpdate(values);
			String s=tv.getText().toString();
			tv.setText(s+"+");
		}
		@Override
		protected Void doInBackground(Void... params) {
			try {
				for(int i=0;i&lt;10;i++){
					Thread.sleep(1000);
					publishProgress(null);
				}
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			return null;
		}
		@Override
		protected void onPostExecute(Void result) {
			tv.setText("完成");
			super.onPostExecute(result);
		}
	}
}
</pre>
<p>　　AsyncTask的参数以及使用方法：一个完整的asyncTask需要经历三次传递参数。第一次传参，execute（）启动时传递给doInBackground（），如需要复制哪个文件，数据上传至哪个服务器等；第二次传参，是doInBackground（）在调用 publishProgress（）时传递给onProgressUpdate（）如：目前的下载进度，已经下载到服务器的列表；第三次传参，是doInBackground（）在运行完以后传递参数给onPostExecute（），如数据获取是否成功。</p>
<p>AsyncTask定义了三种泛型类型参数分别是Params，Progress和Result，即AsyncTask&lt;Params,Progress,Result&gt;;Params是启动任务执行的参数，比如Http的请求URL；Progress后台执行的百分比；Result后台执行的任务最终返回的结果，比如String，下面以一个demo来说明</p>
<p>效果图如下</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcyOTM5NC8yMDE2MDMvNzI5Mzk0LTIwMTYwMzA1MTk0NDQ2Mjk5LTE3MDM1Mjg3MTIucG5n.jpg" /></p>
<p>demo代码如下</p>
<pre>package com.example.asynctaskparams;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity {

	private MyTask task;
	private Button btnStart,btnClose;
	private TextView txtContext;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		btnStart=(Button)findViewById(R.id.btnStart);
		btnClose=(Button)findViewById(R.id.btnClose);
		txtContext=(TextView)findViewById(R.id.txtContext);

		btnStart.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				task=new MyTask();
				//Task发送第一个Task的参数
				task.execute(15);
			}
		});
		btnClose.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				task.cancel(true);
				task=null;
				txtContext.setText("Close");
			}
		});
	}
	@Override
	protected void onDestroy() {
		if(task!=null){
			task.cancel(true);
		}
		super.onDestroy();
	}
	class MyTask extends AsyncTask&lt;Integer, Integer, Boolean&gt;{

		@Override
		protected void onPreExecute() {
			txtContext.setText("开始");
			super.onPreExecute();
		}
		@Override
		protected void onProgressUpdate(Integer... values) {
			//Task在此方法体中使用第二个参数
			txtContext.setText(""+values[0]);
			super.onProgressUpdate(values);
		}
		@Override
		protected Boolean doInBackground(Integer... params) {
			//Task使用第一个参数
			for(int i=0;i&lt;params[0];i++){
				//Task发送第二个参数
				publishProgress(i);
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			//Task发送第三个参数
			return true;
		}
		@Override
		protected void onPostExecute(Boolean result) {
			//Task使用第三个参数
			txtContext.setText(""+result);
			super.onPostExecute(result);
		}

	}
}
</pre>
<p>　　</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 16:24:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android多线程消息处理机制的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzaBwO4.html" rel="bookmark">Android异步消息处理机制&lpar;3&rpar;asyncTask基本使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自android官方文档,结合自己测试,整理如下. 概述 AsyncTask抽象类,翻译过来就是异步任务,能够合理并方便的使用UI线程.该类可以实现将后台操作结果显示在UI线程中,而不需要我们自己实现子线程或者handler(当然它内部也是借助这两者实现的). 虽然AsyncTask可以提供后台运行并将结果显示在UI上,但是理想情况应该是后台操作最多只能是几秒钟,若要执行长时间的操作强烈建议使用java中的Executor,ThreadPoolExecutor,FutureTask等.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0doggZM.html" rel="bookmark">&lbrack;学习总结&rsqb;6、Android异步消息处理机制完全解析，带你从源码的角度彻底理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开始进入正题,我们都知道,Android UI是线程不安全的,如果在子线程中尝试进行UI操作,程序就有可能会崩溃.相信大家在日常的工作当中都会经常遇到这个问题,解决的方案应该也是早已烂熟于心,即创建一个Message对象,然后借助Handler发送出去,之后在Handler的handleMessage()方法中获得刚才发送的Message对象,然后在这里进行UI操作就不会再出现崩溃了. 这种处理方式被称为异步消息处理线程,虽然我相信大家都会用,可是你知道它背后的原理是什么样的吗?今天我们就来一起			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgR17R4.html" rel="bookmark">Android异步消息处理机制&lpar;4&rpar;AsyncTask源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一章我们学习了抽象类AsyncTask的基本使用(地址:http://blog.csdn.net/wangyongge85/article/details/47988569),下面我将以问答的方法分析AsyncTask源码内容,源码版本为:API22. 1. 为什么必须在UI线程实例化我们的AsyncTask,并且必须在主线程中调用execute(Params... params)? 在分析为什么在UI线程调用之前,我们先看一下实例化AsyncTask并调用execute(Params...			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVvLdQM.html" rel="bookmark">【转】android的消息处理机制（图&plus;源码分析）&mdash;&mdash;Looper&comma;Handler&comma;Message</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:http://www.cnblogs.com/codingmyworld/archive/2011/09/12/2174255.html#!comments 作为一个大三的预备程序员,我学习android的一大乐趣是可以通过源码学习google大牛们的设计思想.android源码中包含了大量的设计模式,除此以外,android sdk还精心为我们设计了各种helper类,对于和我一样渴望水平得到进阶的人来说,都太值得一读了.这不,前几天为了了解android的消息处理机制,我看了Loo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xXXar0.html" rel="bookmark">android 的消息处理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				android的消息处理机制(图+源码分析)——Looper,Handler,Message android的消息处理有三个核心类:Looper,Handler和Message.其实还有一个Message Queue(消息队列),但是MQ被封装到Looper里面了,我们不会直接与MQ打交道,因此我没将其作为核心类.下面一一介绍: 线程的魔法师 Looper Looper的字面意思是“循环者”,它被设计用来使一个普通线程变成Looper线程.所谓Looper线程就是循环工作的线程.在程序开发中(尤			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWQmVa3.html" rel="bookmark">Android异步消息处理机制详解及源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PS一句:最终还是选择CSDN来整理发表这几年的知识点,该文章平行迁移到CSDN.因为CSDN也支持MarkDown语法了,牛逼啊! [工匠若水 http://blog.csdn.net/yanbober 转载烦请注明出处,尊重分享成果] 最近相对来说比较闲,加上养病,所以没事干就撸些自己之前的知识点为博客,方便自己也方便别人. 1 背景 之所以选择这个知识点来分析有以下几个原因: 逛GitHub时发现关注的isuss中有人不停的在讨论Android中的Looper , Handler , Me			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPOQya4.html" rel="bookmark">Android异步消息处理机制&lpar;2&rpar;源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一章讲解了Android异步消息处理机制的基本使用,下面将简单地探寻一下异步机制背后的奥妙,源码版本为:API22. 首先,声明一下本文是在我参考了一下各位大神的文章之后才慢慢熟悉的, 若有不足之处,还望各位批评指正!.菜鸟上路,,,, 郭霖博客 鸿洋博客 刘超 深入解析android5.0系统 任玉刚博客 先后顺序按照拼音排序,无关技术本身. 先简单地总结一下Looper,MessageQueue,Message和Handler四者之间的关系: Looper和MessageQueue Loo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rqdog0.html" rel="bookmark">android即时消息处理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在android端做即时消息的时候,遇到的坑点是怎么保证消息即时性,又不耗电.为什么这么说呢? 原因是如果要保证消息即时性,通常有两种机制pull或者push.pull定时轮询机制,比较浪费服务器资源:push服务器推送机制,需要保持长连接,客户端和服务器都要求比较高(网络环境,服务器保持连接数等),它们的详细优缺点不描述了.上面这两种机制都要求客户端长期处于活动状态,前提是cpu处于唤醒状态,而android端有休眠机制,保证手机在大部分时间里都是处于休眠,降低耗电量,延长机时间.手机休眠后,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xXr9N0.html" rel="bookmark">android的消息处理机制&mdash;&mdash;Looper，Handler，Message</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章有一半是copy别人的,站在巨人的肩膀上,我们才能看得更高更远...... 在开始讨论android的消息处理机制前,先来谈谈一些基本相关的术语. 通信的同步(Synchronous):指向客户端发送请求后,必须要在服务端有回应后客户端才继续发送其它的请求,所以这时所有请求将会在服务端得到同步,直到服务端返回请求. 通信的异步(Asynchronous):指客户端在发送请求后,不必等待服务端的回应就可以发送下一个请求. 所谓同步调用,就是在一个函数或方法调用时,没有得到结果之前,该调用就			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgj1L4.html" rel="bookmark" class="title">Unique Binary Search Trees</a>
					<div>
						Given n, how many structurally unique BST's (binary search trees) that store values 1...n? For examp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41jDkM.html" rel="bookmark" class="title">线性表的链式表示和实现--单链表</a>
					<div>
						单链表分为:动态链表.静态链表两种. 单链表的定义 链式存储:用一组任意存储单元存储线性表的数据元素. 逻辑顺序与物理顺序可以相同也可以不相同 插入.删除方便,共享空间好. 单链表的节点结构 每个结点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dr2n4.html" rel="bookmark" class="title">VS复习 --  if&amp;&num;183&semi;&amp;&num;183&semi;&amp;&num;183&semi;else和if&amp;&num;183&semi;&amp;&num;183&semi;&amp;&num;183&semi;else嵌套语句</a>
					<div>
						注意:理清逻辑,画出逻辑分支图,理清思路 1.if语句 2.if...else语句 3.if..else if...else 1 static void Main(string[] args) 2 { ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJ7Yy4.html" rel="bookmark" class="title">vs2017的 &period;net core 在Ubuntu16&period;04上的风雨历程</a>
					<div>
						2017年3月7日,vs2017正式发布,里面的.net core为v1.1.1版本.跨平台,为了实现这个伟大的目标,在漫长的过程中,狼狈的被坑了又坑...终于,哈哈,成功了. 共享一下,那些坑吧.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWlKL0.html" rel="bookmark" class="title">django-rest-framework笔记-请求与响应篇</a>
					<div>
						一.请求对象 request.POST # 处理表单数据. 限于POST请求. request.data # 处理任意数据. 对 'POST', 'PUT' and 'PATCH' 方法. 二.响应对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QNPl2M.html" rel="bookmark" class="title">kafka-topics&period;sh --describe显示结果解释</a>
					<div>
						&gt; bin/kafka-topics.sh --describe --zookeeper localhost:2181 --topic my-replicated-topicTopic:my-r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWw6qGM.html" rel="bookmark" class="title">select 支持宽高&lpar;高度有兼容问题&rpar;；</a>
					<div>
						&lt;select size=1(默认) size=2 没有下拉效果&gt; &lt;option selected&gt;12&lt;/option&gt; &lt;option selected ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AdvEK3.html" rel="bookmark" class="title">【解惑】让人头疼的&amp;quot&semi;相等&amp;quot&semi;关系</a>
					<div>
						Java中判断相等关系一般有两种手段:(1) “==”关系操作符  (2) equals()方法. 显然,基本数据类型变量之间只能用&quot;==&quot;.而对象之间两种手段都是合法的.但是有很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZAQog0.html" rel="bookmark" class="title">U盘装win8系统--密钥、激活</a>
					<div>
						perface:研一上学期终于结束,能够有空闲开始整理文档整理博客了.首先接手师兄的戴尔的一体机,重装系统,这次算是第一次正式用win8系统了.以后就用win8和ubuntu这两个系统开发学习做研究了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYoKkM.html" rel="bookmark" class="title">JAVA之JDBC的简单使用&lpar;Mysql&rpar;</a>
					<div>
						JDBC增删查改 昨天七七八八的关于Mysql的配置 和 基本使用也算是初步解决了,今天 抽空看了JAVA的JDBC(JAVA DATA BASE CONNECTION)我也不知道我全称拼写对对不对? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGwbd0.html" rel="bookmark" class="title">数论&mdash;&mdash;lucas定理</a>
					<div>
						网上证明很多,虽然没看懂.... 主要解决大组合数取模的情况 百度之星2016 1003 先推公式,再lucas p很大的情况 1e9+7 1 #include&lt;iostream&gt; 2 # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5r7v0.html" rel="bookmark" class="title">XML&lowbar;DOM和XML&lowbar;SAX数据解析&lpar;初学&rpar;</a>
					<div>
						方法一:XML_DOMXML_DOM数据解析 1 //DOM树状解析 一个个节点解析 2 3 /* 4 GData的抓准备工作 5 1.导入动态库: libxml2.dylib 6 2.在buid s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4ARyj5M.html" rel="bookmark" class="title">when to use reentrant lock</a>
					<div>
						The answer is pretty simple -- use it when you actually need something it provides that synchronized ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RDylv4.html" rel="bookmark" class="title">Go语言之Doc 文档</a>
					<div>
						对于协作开发或者代码共享来说,文档是一个可以帮助开发者快速了解以及使用这些代码的一个教程,文档越全面.越详细,入门越快,效率也会更高. 在Go语言中,Go为我们提供了快速生成文档以及查看文档的工具,让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz17Kq4.html" rel="bookmark" class="title">Apache 显示网页</a>
					<div>
						1.  源码包安装情况:[ vi INSTALL ] 查看安装及运行方法说明 运行方法: /usr/local/apache2/bin/apachectl start 网页内容: vi /usr/lo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODBeg4.html" rel="bookmark" class="title">【Foundation Frame】NSString</a>
					<div>
						NSString代表字符序列不可变的字符串,功能更强大,更方便简单. 下面代码列举了大部分常用的NSString方法. // //  main.m //  OcString // //  Create ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6zLvrM.html" rel="bookmark" class="title">Javac源码简单分析之Javac简单介绍</a>
					<div>
						一.简单介绍 javac 是java语言编程编译器.javac工具读由java语言编写的类和接口的定义,并将它们编译成字节代码的class文件. 二.源码获取 OpenJDK6源码:http://do ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymXVaM.html" rel="bookmark" class="title">bootstrap之div居中</a>
					<div>
						bootstrap之div居中 偏移列 偏移是一个用于更专业的布局的有用功能.它们可用来给列腾出更多的空间.例如,.col-xs=* 类不支持偏移,但是它们可以简单地通过使用一个空的单元格来实现该效果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1j8n0.html" rel="bookmark" class="title">php 安装教程</a>
					<div>
						php 安装教程 本文采用php7.0.1作为样例,进行安装. 系统环境: CentOS6.7. gcc 4.8.2 libzip 1.0.1 在安装之前,可以先更新CentOS系统. yum -y  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBxp1Y3.html" rel="bookmark" class="title">Java笔试面试高频题目</a>
					<div>
						1.项目经历,项目流程图,程序执行流程 2.进程间通信 (1)管道(pipe)和有名管道(FIFO)(2)信号(signal)(3)消息队列(4)共享内存(5)信号量(6)套接字(socket) 3. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
